/*
 *    Entropy.java
 *    Copyright (C) 1999 Pierre Geurts
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.io.*;

/* this class contains some functions to calculate 
 * entropy values
 */
public class Entropy{
  static double entropy(int freq[], int size, int sum) {
    // when we don't have example then the entropy is zero
    if (sum==0)
      return 0.0;
    double result=sum*java.lang.Math.log(sum);
    for (int i=0; i<size; i++) {
      if (freq[i]!=0) 
	result-=freq[i]*java.lang.Math.log(freq[i]);
    }
    result/=java.lang.Math.log((double)2.0);
    result/=sum;
    return result;
  }
}
