/*
 *    Test.java
 *    Copyright (C) 1999 Pierre Geurts
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.util.*;

/* a test should also be an extension of a Symbolic Attribute
 * so that we could use it later
 */
abstract class Test {
  /* a description of the test */
  String TestDescription;
  /* the attribute */
  Attribute Att;
  /* the number of issues of this test */
  int nbIssues;
  /* the vector of the values corresponding to each issues */
  Vector valuesIssues;
  /* TestObject gives the value associated to this object */
  abstract String TestObject(Obj o);
  /* return a description of the nth value of this test */
  abstract String testDescription(int value);
  /* TestIndex gives the index of this values in valuesissues */  
  public int TestIndex(Obj o) {
    return valuesIssues.indexOf(TestObject(o));
  }
}
  
